#include "Sprite.h"
#include "VVram.h"
#include "Vram.h"

extern byte[] SpriteChars;

constexpr byte InvalidY = 0xe0;
struct Sprite {
    byte x, y;
    byte[4] chars;
};
Sprite[SpriteCount] Sprites;

void InitSprites() {
    HideAllSprites();
}

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
    }
}


void ShowSprite(byte index, byte x, byte y, ptr<byte> pChars)
{
    ptr<Sprite> p;
    ptr<byte> pDestination;
    p = Sprites + index;
    p->x = x;
    p->y = y;
    pDestination = p->chars;
    repeat(4) {
        *pDestination = *pChars;
        ++pChars;
        ++pDestination;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->y = InvalidY;
}


void DrawSprites()
{
    bool changed;
    ptr<Sprite> p;
    changed = false;
    for (p : Sprites) {
        if (p->y != InvalidY) {
            ptr<byte> pVVram, pChar;
            byte x, y;
            x = p->x;
            y = p->y;
            pVVram = VVramPtr(x, y);
            pChar = p->chars;
            repeat (2) {
                if (y < WindowHeight) {
                    repeat (2) {
                        byte c;
                        c = *pChar;
                        if (c != 0 && x < WindowWidth) {
                            *pVVram = c;
                        }
                        ++pVVram;
                        ++pChar;
                        ++x;
                    }
                    x -= 2;
                }
                pVVram += WindowWidth - 2;
                ++y;
            }
        }
    }
}
